/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import * as cdktf from 'cdktf';
import { DataDatabricksJobJobSettingsSettingsCompute, DataDatabricksJobJobSettingsSettingsComputeList, DataDatabricksJobJobSettingsSettingsContinuous, DataDatabricksJobJobSettingsSettingsContinuousOutputReference, DataDatabricksJobJobSettingsSettingsDbtTask, DataDatabricksJobJobSettingsSettingsDbtTaskOutputReference, DataDatabricksJobJobSettingsSettingsDeployment, DataDatabricksJobJobSettingsSettingsDeploymentOutputReference, DataDatabricksJobJobSettingsSettingsEmailNotifications, DataDatabricksJobJobSettingsSettingsEmailNotificationsOutputReference, DataDatabricksJobJobSettingsSettingsGitSource, DataDatabricksJobJobSettingsSettingsGitSourceOutputReference, DataDatabricksJobJobSettingsSettingsHealth, DataDatabricksJobJobSettingsSettingsHealthOutputReference, DataDatabricksJobJobSettingsSettingsJobCluster, DataDatabricksJobJobSettingsSettingsJobClusterList, DataDatabricksJobJobSettingsSettingsLibrary, DataDatabricksJobJobSettingsSettingsLibraryList, DataDatabricksJobJobSettingsSettingsNewCluster, DataDatabricksJobJobSettingsSettingsNewClusterOutputReference, DataDatabricksJobJobSettingsSettingsNotebookTask, DataDatabricksJobJobSettingsSettingsNotebookTaskOutputReference, DataDatabricksJobJobSettingsSettingsNotificationSettings, DataDatabricksJobJobSettingsSettingsNotificationSettingsOutputReference, DataDatabricksJobJobSettingsSettingsParameter, DataDatabricksJobJobSettingsSettingsParameterList, DataDatabricksJobJobSettingsSettingsPipelineTask, DataDatabricksJobJobSettingsSettingsPipelineTaskOutputReference, DataDatabricksJobJobSettingsSettingsPythonWheelTask, DataDatabricksJobJobSettingsSettingsPythonWheelTaskOutputReference, DataDatabricksJobJobSettingsSettingsQueue, DataDatabricksJobJobSettingsSettingsQueueOutputReference, DataDatabricksJobJobSettingsSettingsRunAs, DataDatabricksJobJobSettingsSettingsRunAsOutputReference, DataDatabricksJobJobSettingsSettingsRunJobTask, DataDatabricksJobJobSettingsSettingsRunJobTaskOutputReference, DataDatabricksJobJobSettingsSettingsSchedule, DataDatabricksJobJobSettingsSettingsScheduleOutputReference, DataDatabricksJobJobSettingsSettingsSparkJarTask, DataDatabricksJobJobSettingsSettingsSparkJarTaskOutputReference, DataDatabricksJobJobSettingsSettingsSparkPythonTask, DataDatabricksJobJobSettingsSettingsSparkPythonTaskOutputReference, DataDatabricksJobJobSettingsSettingsSparkSubmitTask, DataDatabricksJobJobSettingsSettingsSparkSubmitTaskOutputReference, DataDatabricksJobJobSettingsSettingsTask, DataDatabricksJobJobSettingsSettingsTaskList, DataDatabricksJobJobSettingsSettingsTrigger, DataDatabricksJobJobSettingsSettingsTriggerOutputReference } from './structs0';
export interface DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceeded {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#id DataDatabricksJob#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export declare function dataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceededToTerraform(struct?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceeded | cdktf.IResolvable): any;
export declare class DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceededOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceeded | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceeded | cdktf.IResolvable | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
}
export declare class DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceededList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceeded[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceededOutputReference;
}
export interface DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailure {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#id DataDatabricksJob#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export declare function dataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailureToTerraform(struct?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailure | cdktf.IResolvable): any;
export declare class DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailureOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailure | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailure | cdktf.IResolvable | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
}
export declare class DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailureList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailure[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailureOutputReference;
}
export interface DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStart {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#id DataDatabricksJob#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export declare function dataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStartToTerraform(struct?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStart | cdktf.IResolvable): any;
export declare class DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStartOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStart | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStart | cdktf.IResolvable | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
}
export declare class DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStartList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStart[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStartOutputReference;
}
export interface DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccess {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#id DataDatabricksJob#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
export declare function dataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccessToTerraform(struct?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccess | cdktf.IResolvable): any;
export declare class DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccessOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccess | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccess | cdktf.IResolvable | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
}
export declare class DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccessList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccess[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccessOutputReference;
}
export interface DataDatabricksJobJobSettingsSettingsWebhookNotifications {
    /**
    * on_duration_warning_threshold_exceeded block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#on_duration_warning_threshold_exceeded DataDatabricksJob#on_duration_warning_threshold_exceeded}
    */
    readonly onDurationWarningThresholdExceeded?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceeded[] | cdktf.IResolvable;
    /**
    * on_failure block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#on_failure DataDatabricksJob#on_failure}
    */
    readonly onFailure?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailure[] | cdktf.IResolvable;
    /**
    * on_start block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#on_start DataDatabricksJob#on_start}
    */
    readonly onStart?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStart[] | cdktf.IResolvable;
    /**
    * on_success block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#on_success DataDatabricksJob#on_success}
    */
    readonly onSuccess?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccess[] | cdktf.IResolvable;
}
export declare function dataDatabricksJobJobSettingsSettingsWebhookNotificationsToTerraform(struct?: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOutputReference | DataDatabricksJobJobSettingsSettingsWebhookNotifications): any;
export declare class DataDatabricksJobJobSettingsSettingsWebhookNotificationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksJobJobSettingsSettingsWebhookNotifications | undefined;
    set internalValue(value: DataDatabricksJobJobSettingsSettingsWebhookNotifications | undefined);
    private _onDurationWarningThresholdExceeded;
    get onDurationWarningThresholdExceeded(): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceededList;
    putOnDurationWarningThresholdExceeded(value: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceeded[] | cdktf.IResolvable): void;
    resetOnDurationWarningThresholdExceeded(): void;
    get onDurationWarningThresholdExceededInput(): cdktf.IResolvable | DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnDurationWarningThresholdExceeded[] | undefined;
    private _onFailure;
    get onFailure(): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailureList;
    putOnFailure(value: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailure[] | cdktf.IResolvable): void;
    resetOnFailure(): void;
    get onFailureInput(): cdktf.IResolvable | DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnFailure[] | undefined;
    private _onStart;
    get onStart(): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStartList;
    putOnStart(value: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStart[] | cdktf.IResolvable): void;
    resetOnStart(): void;
    get onStartInput(): cdktf.IResolvable | DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnStart[] | undefined;
    private _onSuccess;
    get onSuccess(): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccessList;
    putOnSuccess(value: DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccess[] | cdktf.IResolvable): void;
    resetOnSuccess(): void;
    get onSuccessInput(): cdktf.IResolvable | DataDatabricksJobJobSettingsSettingsWebhookNotificationsOnSuccess[] | undefined;
}
export interface DataDatabricksJobJobSettingsSettings {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#description DataDatabricksJob#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#edit_mode DataDatabricksJob#edit_mode}
    */
    readonly editMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#existing_cluster_id DataDatabricksJob#existing_cluster_id}
    */
    readonly existingClusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#format DataDatabricksJob#format}
    */
    readonly format?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#max_concurrent_runs DataDatabricksJob#max_concurrent_runs}
    */
    readonly maxConcurrentRuns?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#max_retries DataDatabricksJob#max_retries}
    */
    readonly maxRetries?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#min_retry_interval_millis DataDatabricksJob#min_retry_interval_millis}
    */
    readonly minRetryIntervalMillis?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#name DataDatabricksJob#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#retry_on_timeout DataDatabricksJob#retry_on_timeout}
    */
    readonly retryOnTimeout?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#tags DataDatabricksJob#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#timeout_seconds DataDatabricksJob#timeout_seconds}
    */
    readonly timeoutSeconds?: number;
    /**
    * compute block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#compute DataDatabricksJob#compute}
    */
    readonly compute?: DataDatabricksJobJobSettingsSettingsCompute[] | cdktf.IResolvable;
    /**
    * continuous block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#continuous DataDatabricksJob#continuous}
    */
    readonly continuous?: DataDatabricksJobJobSettingsSettingsContinuous;
    /**
    * dbt_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#dbt_task DataDatabricksJob#dbt_task}
    */
    readonly dbtTask?: DataDatabricksJobJobSettingsSettingsDbtTask;
    /**
    * deployment block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#deployment DataDatabricksJob#deployment}
    */
    readonly deployment?: DataDatabricksJobJobSettingsSettingsDeployment;
    /**
    * email_notifications block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#email_notifications DataDatabricksJob#email_notifications}
    */
    readonly emailNotifications?: DataDatabricksJobJobSettingsSettingsEmailNotifications;
    /**
    * git_source block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#git_source DataDatabricksJob#git_source}
    */
    readonly gitSource?: DataDatabricksJobJobSettingsSettingsGitSource;
    /**
    * health block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#health DataDatabricksJob#health}
    */
    readonly health?: DataDatabricksJobJobSettingsSettingsHealth;
    /**
    * job_cluster block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#job_cluster DataDatabricksJob#job_cluster}
    */
    readonly jobCluster?: DataDatabricksJobJobSettingsSettingsJobCluster[] | cdktf.IResolvable;
    /**
    * library block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#library DataDatabricksJob#library}
    */
    readonly library?: DataDatabricksJobJobSettingsSettingsLibrary[] | cdktf.IResolvable;
    /**
    * new_cluster block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#new_cluster DataDatabricksJob#new_cluster}
    */
    readonly newCluster?: DataDatabricksJobJobSettingsSettingsNewCluster;
    /**
    * notebook_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#notebook_task DataDatabricksJob#notebook_task}
    */
    readonly notebookTask?: DataDatabricksJobJobSettingsSettingsNotebookTask;
    /**
    * notification_settings block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#notification_settings DataDatabricksJob#notification_settings}
    */
    readonly notificationSettings?: DataDatabricksJobJobSettingsSettingsNotificationSettings;
    /**
    * parameter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#parameter DataDatabricksJob#parameter}
    */
    readonly parameter?: DataDatabricksJobJobSettingsSettingsParameter[] | cdktf.IResolvable;
    /**
    * pipeline_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#pipeline_task DataDatabricksJob#pipeline_task}
    */
    readonly pipelineTask?: DataDatabricksJobJobSettingsSettingsPipelineTask;
    /**
    * python_wheel_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#python_wheel_task DataDatabricksJob#python_wheel_task}
    */
    readonly pythonWheelTask?: DataDatabricksJobJobSettingsSettingsPythonWheelTask;
    /**
    * queue block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#queue DataDatabricksJob#queue}
    */
    readonly queue?: DataDatabricksJobJobSettingsSettingsQueue;
    /**
    * run_as block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#run_as DataDatabricksJob#run_as}
    */
    readonly runAs?: DataDatabricksJobJobSettingsSettingsRunAs;
    /**
    * run_job_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#run_job_task DataDatabricksJob#run_job_task}
    */
    readonly runJobTask?: DataDatabricksJobJobSettingsSettingsRunJobTask;
    /**
    * schedule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#schedule DataDatabricksJob#schedule}
    */
    readonly schedule?: DataDatabricksJobJobSettingsSettingsSchedule;
    /**
    * spark_jar_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#spark_jar_task DataDatabricksJob#spark_jar_task}
    */
    readonly sparkJarTask?: DataDatabricksJobJobSettingsSettingsSparkJarTask;
    /**
    * spark_python_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#spark_python_task DataDatabricksJob#spark_python_task}
    */
    readonly sparkPythonTask?: DataDatabricksJobJobSettingsSettingsSparkPythonTask;
    /**
    * spark_submit_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#spark_submit_task DataDatabricksJob#spark_submit_task}
    */
    readonly sparkSubmitTask?: DataDatabricksJobJobSettingsSettingsSparkSubmitTask;
    /**
    * task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#task DataDatabricksJob#task}
    */
    readonly task?: DataDatabricksJobJobSettingsSettingsTask[] | cdktf.IResolvable;
    /**
    * trigger block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#trigger DataDatabricksJob#trigger}
    */
    readonly trigger?: DataDatabricksJobJobSettingsSettingsTrigger;
    /**
    * webhook_notifications block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#webhook_notifications DataDatabricksJob#webhook_notifications}
    */
    readonly webhookNotifications?: DataDatabricksJobJobSettingsSettingsWebhookNotifications;
}
export declare function dataDatabricksJobJobSettingsSettingsToTerraform(struct?: DataDatabricksJobJobSettingsSettingsOutputReference | DataDatabricksJobJobSettingsSettings): any;
export declare class DataDatabricksJobJobSettingsSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksJobJobSettingsSettings | undefined;
    set internalValue(value: DataDatabricksJobJobSettingsSettings | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _editMode?;
    get editMode(): string;
    set editMode(value: string);
    resetEditMode(): void;
    get editModeInput(): string | undefined;
    private _existingClusterId?;
    get existingClusterId(): string;
    set existingClusterId(value: string);
    resetExistingClusterId(): void;
    get existingClusterIdInput(): string | undefined;
    private _format?;
    get format(): string;
    set format(value: string);
    resetFormat(): void;
    get formatInput(): string | undefined;
    private _maxConcurrentRuns?;
    get maxConcurrentRuns(): number;
    set maxConcurrentRuns(value: number);
    resetMaxConcurrentRuns(): void;
    get maxConcurrentRunsInput(): number | undefined;
    private _maxRetries?;
    get maxRetries(): number;
    set maxRetries(value: number);
    resetMaxRetries(): void;
    get maxRetriesInput(): number | undefined;
    private _minRetryIntervalMillis?;
    get minRetryIntervalMillis(): number;
    set minRetryIntervalMillis(value: number);
    resetMinRetryIntervalMillis(): void;
    get minRetryIntervalMillisInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _retryOnTimeout?;
    get retryOnTimeout(): boolean | cdktf.IResolvable;
    set retryOnTimeout(value: boolean | cdktf.IResolvable);
    resetRetryOnTimeout(): void;
    get retryOnTimeoutInput(): boolean | cdktf.IResolvable | undefined;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _timeoutSeconds?;
    get timeoutSeconds(): number;
    set timeoutSeconds(value: number);
    resetTimeoutSeconds(): void;
    get timeoutSecondsInput(): number | undefined;
    private _compute;
    get compute(): DataDatabricksJobJobSettingsSettingsComputeList;
    putCompute(value: DataDatabricksJobJobSettingsSettingsCompute[] | cdktf.IResolvable): void;
    resetCompute(): void;
    get computeInput(): cdktf.IResolvable | DataDatabricksJobJobSettingsSettingsCompute[] | undefined;
    private _continuous;
    get continuous(): DataDatabricksJobJobSettingsSettingsContinuousOutputReference;
    putContinuous(value: DataDatabricksJobJobSettingsSettingsContinuous): void;
    resetContinuous(): void;
    get continuousInput(): DataDatabricksJobJobSettingsSettingsContinuous | undefined;
    private _dbtTask;
    get dbtTask(): DataDatabricksJobJobSettingsSettingsDbtTaskOutputReference;
    putDbtTask(value: DataDatabricksJobJobSettingsSettingsDbtTask): void;
    resetDbtTask(): void;
    get dbtTaskInput(): DataDatabricksJobJobSettingsSettingsDbtTask | undefined;
    private _deployment;
    get deployment(): DataDatabricksJobJobSettingsSettingsDeploymentOutputReference;
    putDeployment(value: DataDatabricksJobJobSettingsSettingsDeployment): void;
    resetDeployment(): void;
    get deploymentInput(): DataDatabricksJobJobSettingsSettingsDeployment | undefined;
    private _emailNotifications;
    get emailNotifications(): DataDatabricksJobJobSettingsSettingsEmailNotificationsOutputReference;
    putEmailNotifications(value: DataDatabricksJobJobSettingsSettingsEmailNotifications): void;
    resetEmailNotifications(): void;
    get emailNotificationsInput(): DataDatabricksJobJobSettingsSettingsEmailNotifications | undefined;
    private _gitSource;
    get gitSource(): DataDatabricksJobJobSettingsSettingsGitSourceOutputReference;
    putGitSource(value: DataDatabricksJobJobSettingsSettingsGitSource): void;
    resetGitSource(): void;
    get gitSourceInput(): DataDatabricksJobJobSettingsSettingsGitSource | undefined;
    private _health;
    get health(): DataDatabricksJobJobSettingsSettingsHealthOutputReference;
    putHealth(value: DataDatabricksJobJobSettingsSettingsHealth): void;
    resetHealth(): void;
    get healthInput(): DataDatabricksJobJobSettingsSettingsHealth | undefined;
    private _jobCluster;
    get jobCluster(): DataDatabricksJobJobSettingsSettingsJobClusterList;
    putJobCluster(value: DataDatabricksJobJobSettingsSettingsJobCluster[] | cdktf.IResolvable): void;
    resetJobCluster(): void;
    get jobClusterInput(): cdktf.IResolvable | DataDatabricksJobJobSettingsSettingsJobCluster[] | undefined;
    private _library;
    get library(): DataDatabricksJobJobSettingsSettingsLibraryList;
    putLibrary(value: DataDatabricksJobJobSettingsSettingsLibrary[] | cdktf.IResolvable): void;
    resetLibrary(): void;
    get libraryInput(): cdktf.IResolvable | DataDatabricksJobJobSettingsSettingsLibrary[] | undefined;
    private _newCluster;
    get newCluster(): DataDatabricksJobJobSettingsSettingsNewClusterOutputReference;
    putNewCluster(value: DataDatabricksJobJobSettingsSettingsNewCluster): void;
    resetNewCluster(): void;
    get newClusterInput(): DataDatabricksJobJobSettingsSettingsNewCluster | undefined;
    private _notebookTask;
    get notebookTask(): DataDatabricksJobJobSettingsSettingsNotebookTaskOutputReference;
    putNotebookTask(value: DataDatabricksJobJobSettingsSettingsNotebookTask): void;
    resetNotebookTask(): void;
    get notebookTaskInput(): DataDatabricksJobJobSettingsSettingsNotebookTask | undefined;
    private _notificationSettings;
    get notificationSettings(): DataDatabricksJobJobSettingsSettingsNotificationSettingsOutputReference;
    putNotificationSettings(value: DataDatabricksJobJobSettingsSettingsNotificationSettings): void;
    resetNotificationSettings(): void;
    get notificationSettingsInput(): DataDatabricksJobJobSettingsSettingsNotificationSettings | undefined;
    private _parameter;
    get parameter(): DataDatabricksJobJobSettingsSettingsParameterList;
    putParameter(value: DataDatabricksJobJobSettingsSettingsParameter[] | cdktf.IResolvable): void;
    resetParameter(): void;
    get parameterInput(): cdktf.IResolvable | DataDatabricksJobJobSettingsSettingsParameter[] | undefined;
    private _pipelineTask;
    get pipelineTask(): DataDatabricksJobJobSettingsSettingsPipelineTaskOutputReference;
    putPipelineTask(value: DataDatabricksJobJobSettingsSettingsPipelineTask): void;
    resetPipelineTask(): void;
    get pipelineTaskInput(): DataDatabricksJobJobSettingsSettingsPipelineTask | undefined;
    private _pythonWheelTask;
    get pythonWheelTask(): DataDatabricksJobJobSettingsSettingsPythonWheelTaskOutputReference;
    putPythonWheelTask(value: DataDatabricksJobJobSettingsSettingsPythonWheelTask): void;
    resetPythonWheelTask(): void;
    get pythonWheelTaskInput(): DataDatabricksJobJobSettingsSettingsPythonWheelTask | undefined;
    private _queue;
    get queue(): DataDatabricksJobJobSettingsSettingsQueueOutputReference;
    putQueue(value: DataDatabricksJobJobSettingsSettingsQueue): void;
    resetQueue(): void;
    get queueInput(): DataDatabricksJobJobSettingsSettingsQueue | undefined;
    private _runAs;
    get runAs(): DataDatabricksJobJobSettingsSettingsRunAsOutputReference;
    putRunAs(value: DataDatabricksJobJobSettingsSettingsRunAs): void;
    resetRunAs(): void;
    get runAsInput(): DataDatabricksJobJobSettingsSettingsRunAs | undefined;
    private _runJobTask;
    get runJobTask(): DataDatabricksJobJobSettingsSettingsRunJobTaskOutputReference;
    putRunJobTask(value: DataDatabricksJobJobSettingsSettingsRunJobTask): void;
    resetRunJobTask(): void;
    get runJobTaskInput(): DataDatabricksJobJobSettingsSettingsRunJobTask | undefined;
    private _schedule;
    get schedule(): DataDatabricksJobJobSettingsSettingsScheduleOutputReference;
    putSchedule(value: DataDatabricksJobJobSettingsSettingsSchedule): void;
    resetSchedule(): void;
    get scheduleInput(): DataDatabricksJobJobSettingsSettingsSchedule | undefined;
    private _sparkJarTask;
    get sparkJarTask(): DataDatabricksJobJobSettingsSettingsSparkJarTaskOutputReference;
    putSparkJarTask(value: DataDatabricksJobJobSettingsSettingsSparkJarTask): void;
    resetSparkJarTask(): void;
    get sparkJarTaskInput(): DataDatabricksJobJobSettingsSettingsSparkJarTask | undefined;
    private _sparkPythonTask;
    get sparkPythonTask(): DataDatabricksJobJobSettingsSettingsSparkPythonTaskOutputReference;
    putSparkPythonTask(value: DataDatabricksJobJobSettingsSettingsSparkPythonTask): void;
    resetSparkPythonTask(): void;
    get sparkPythonTaskInput(): DataDatabricksJobJobSettingsSettingsSparkPythonTask | undefined;
    private _sparkSubmitTask;
    get sparkSubmitTask(): DataDatabricksJobJobSettingsSettingsSparkSubmitTaskOutputReference;
    putSparkSubmitTask(value: DataDatabricksJobJobSettingsSettingsSparkSubmitTask): void;
    resetSparkSubmitTask(): void;
    get sparkSubmitTaskInput(): DataDatabricksJobJobSettingsSettingsSparkSubmitTask | undefined;
    private _task;
    get task(): DataDatabricksJobJobSettingsSettingsTaskList;
    putTask(value: DataDatabricksJobJobSettingsSettingsTask[] | cdktf.IResolvable): void;
    resetTask(): void;
    get taskInput(): cdktf.IResolvable | DataDatabricksJobJobSettingsSettingsTask[] | undefined;
    private _trigger;
    get trigger(): DataDatabricksJobJobSettingsSettingsTriggerOutputReference;
    putTrigger(value: DataDatabricksJobJobSettingsSettingsTrigger): void;
    resetTrigger(): void;
    get triggerInput(): DataDatabricksJobJobSettingsSettingsTrigger | undefined;
    private _webhookNotifications;
    get webhookNotifications(): DataDatabricksJobJobSettingsSettingsWebhookNotificationsOutputReference;
    putWebhookNotifications(value: DataDatabricksJobJobSettingsSettingsWebhookNotifications): void;
    resetWebhookNotifications(): void;
    get webhookNotificationsInput(): DataDatabricksJobJobSettingsSettingsWebhookNotifications | undefined;
}
export interface DataDatabricksJobJobSettings {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#created_time DataDatabricksJob#created_time}
    */
    readonly createdTime?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#creator_user_name DataDatabricksJob#creator_user_name}
    */
    readonly creatorUserName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#job_id DataDatabricksJob#job_id}
    */
    readonly jobId?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#run_as_user_name DataDatabricksJob#run_as_user_name}
    */
    readonly runAsUserName?: string;
    /**
    * settings block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/data-sources/job#settings DataDatabricksJob#settings}
    */
    readonly settings?: DataDatabricksJobJobSettingsSettings;
}
export declare function dataDatabricksJobJobSettingsToTerraform(struct?: DataDatabricksJobJobSettingsOutputReference | DataDatabricksJobJobSettings): any;
export declare class DataDatabricksJobJobSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatabricksJobJobSettings | undefined;
    set internalValue(value: DataDatabricksJobJobSettings | undefined);
    private _createdTime?;
    get createdTime(): number;
    set createdTime(value: number);
    resetCreatedTime(): void;
    get createdTimeInput(): number | undefined;
    private _creatorUserName?;
    get creatorUserName(): string;
    set creatorUserName(value: string);
    resetCreatorUserName(): void;
    get creatorUserNameInput(): string | undefined;
    private _jobId?;
    get jobId(): number;
    set jobId(value: number);
    resetJobId(): void;
    get jobIdInput(): number | undefined;
    private _runAsUserName?;
    get runAsUserName(): string;
    set runAsUserName(value: string);
    resetRunAsUserName(): void;
    get runAsUserNameInput(): string | undefined;
    private _settings;
    get settings(): DataDatabricksJobJobSettingsSettingsOutputReference;
    putSettings(value: DataDatabricksJobJobSettingsSettings): void;
    resetSettings(): void;
    get settingsInput(): DataDatabricksJobJobSettingsSettings | undefined;
}
