/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface WorkspaceConfConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/resources/workspace_conf#custom_config WorkspaceConf#custom_config}
    */
    readonly customConfig?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/resources/workspace_conf#id WorkspaceConf#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/resources/workspace_conf databricks_workspace_conf}
*/
export declare class WorkspaceConf extends cdktf.TerraformResource {
    static readonly tfResourceType = "databricks_workspace_conf";
    /**
    * Generates CDKTF code for importing a WorkspaceConf resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the WorkspaceConf to import
    * @param importFromId The id of the existing WorkspaceConf that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/resources/workspace_conf#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the WorkspaceConf to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.32.0/docs/resources/workspace_conf databricks_workspace_conf} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options WorkspaceConfConfig = {}
    */
    constructor(scope: Construct, id: string, config?: WorkspaceConfConfig);
    private _customConfig?;
    get customConfig(): {
        [key: string]: string;
    };
    set customConfig(value: {
        [key: string]: string;
    });
    resetCustomConfig(): void;
    get customConfigInput(): {
        [key: string]: string;
    } | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
